=== debian/changelog ===
prismlauncher (10.0.2+dfsg-1) unstable; urgency=medium

  * Initial Package (Closes: #898972)

 -- Ben Westover <bjw@debian.org>  Thu, 12 Feb 2026 14:18:22 -0500
