=== debian/control ===
Source: prismlauncher
Section: contrib/games
Maintainer: Ben Westover <bjw@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 extra-cmake-modules,
 pkgconf,
 openjdk-17-jdk,
 zlib1g-dev,
 libtomlplusplus-dev,
 libarchive-dev,
 libqrencode-dev,
 libcmark-dev,
 libgamemode0,
 gamemode-dev,
 qt6-base-dev,
 qt6-networkauth-dev,
 cmark
Standards-Version: 4.7.3
Vcs-Git: https://salsa.debian.org/debian/prismlauncher.git
Vcs-Browser: https://salsa.debian.org/debian/prismlauncher
Homepage: https://prismlauncher.org

Package: prismlauncher
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libqt6svg6, qt6-image-formats-plugins, qt6-wayland, mesa-utils, pciutils
Recommends: default-jre | java-runtime (>= 21), flite, x11-xserver-utils
Suggests: libglfw3-wayland, gamemode, openjdk-8-jre | java-runtime (= 8), openjdk-17-jre | java-runtime (= 17)
Provides: multimc, polymc
Description: FOSS Minecraft launcher supporting multiple instances and accounts
 Prism Launcher is a custom launcher for Minecraft that allows users to
 create multiple instances and use multiple accounts. As a fork of the
 popular MultiMC, it focuses on user freedom, stability, & simplicity.
