=== debian/watch ===
Version: 5
Source: https://github.com/PrismLauncher/PrismLauncher/releases
Matching-Pattern: .*/PrismLauncher@ANY_VERSION@@ARCHIVE_EXT@
Repacksuffix: +dfsg
Dversion-Mangle: auto
