## prismlauncher 10.0.5

=== launcher/CMakeLists.txt ===
--- 
+++ 
@@ -102,6 +102,9 @@
     MMCTime.cpp
 
     MTPixmapCache.h
+
+    # Assertion helper
+    AssertHelpers.h
 )
 if (UNIX AND NOT CYGWIN AND NOT APPLE)
     set(CORE_SOURCES
@@ -261,6 +264,8 @@
     minecraft/launch/ClaimAccount.h
     minecraft/launch/CreateGameFolders.cpp
     minecraft/launch/CreateGameFolders.h
+    minecraft/launch/EnsureOfflineLibraries.cpp
+    minecraft/launch/EnsureOfflineLibraries.h
     minecraft/launch/ModMinecraftJar.cpp
     minecraft/launch/ModMinecraftJar.h
     minecraft/launch/ExtractNatives.cpp
@@ -438,8 +443,3 @@
     java/download/ArchiveDownloadTask.cpp
     java/download/ArchiveDownloadTask.h
     java/download/ManifestDownloadTask.cpp
-    java/download/ManifestDownloadTask.h
-    java/download/SymlinkTask.cpp
-    java/download/SymlinkTask.h
-
-    ui/java/InstallJavaDialog.h
