=== debian/changelog ===
prismlauncher (10.0.5-2) unstable; urgency=medium

  * Remove dependency on openjdk-17-jdk (Closes: #1128100)

 -- Ben Westover <bjw@debian.org>  Mon, 16 Feb 2026 11:35:15 -0500

prismlauncher (10.0.5-1) unstable; urgency=medium

  * New upstream version.
  * Remove tarball repacking.

 -- Ben Westover <bjw@debian.org>  Sat, 14 Feb 2026 18:54:14 -0500
