=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  cmake,
  extra-cmake-modules,
  pkgconf,
- openjdk-17-jdk,
+ default-jdk | java-sdk,
  zlib1g-dev,
  libtomlplusplus-dev,
  libarchive-dev,
@@ -25,8 +25,13 @@
 Package: prismlauncher
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}, libqt6svg6, qt6-image-formats-plugins, qt6-wayland, mesa-utils, pciutils
-Recommends: default-jre | java-runtime (>= 21), flite, x11-xserver-utils
-Suggests: libglfw3-wayland, gamemode, openjdk-8-jre | java-runtime (= 8), openjdk-17-jre | java-runtime (= 17)
+Recommends: default-jre | java-runtime (>= 25), flite, x11-xserver-utils
+Suggests:
+ libglfw3-wayland,
+ gamemode,
+ openjdk-8-jre | java-runtime (= 8),
+ openjdk-17-jre | java-runtime (= 17),
+ openjdk-21-jre | java-runtime (= 21)
 Provides: multimc, polymc
 Description: FOSS Minecraft launcher supporting multiple instances and accounts
  Prism Launcher is a custom launcher for Minecraft that allows users to
